#include "NativeModule.h"
#include "flashlight.h"
#include <ecam.h>

_LIT(FLASH, "flash");

class flash : public NativeModule
	{
private:
	/**
	 * Funzioni supportate dal modulo 
	 */
	enum
		{
		OnFunction,
		OffFunction
		};
	CCameraFlashLight* iFlashlight;

	/**
	 * La funzione attiva il flash della fotocamera.
	 */
	void activate()
		{
		 // CCameraFlashLight is initialized in AppUi and SetVideoLightL() is called:
		 iFlashlight->SetVideoLightL( ETrue );		
		}
	
	/**
	 * Spegne il flash della fotocamera
	 */
	void deactivate()
		{
		 // CCameraFlashLight is initialized in AppUi and SetVideoLightL() is called:
		 iFlashlight->SetVideoLightL( EFalse );
		}
	
protected:
	TInt ExpectedRuntimeVersion()
		{
		return Runtime::VERSION;
		}

	void ConstructL()
		{
		iFlashlight = CCameraFlashLight::NewL();
		runtime->AddNativeFunctionL(_L("on"), 0, 0, OnFunction);
		runtime->AddNativeFunctionL(_L("off"), 0, 0, OffFunction);
		}

	Runtime::Value ExecuteL(TInt index, Runtime::Value *params,
			TInt paramCount, TRequestStatus &status)
		{
		Runtime::Value retval;
		
		switch (index)
			{
			case OnFunction:
				activate();
				break;
			case OffFunction:
				deactivate();
				break;
			}
		retval.SetNull();
		return retval;
		}

	};

//ENTRY POINTS
EXPORT_C NativeModule* NewFlashModuleL()
	{
	return new (ELeave) flash;
	}

#ifndef EKA2
GLDEF_C TInt E32Dll(TDllReason)
	{return KErrNone;}
#endif
