/**
 * Codice ottenuto e revisionato dal sito:
 * http://www.developer.nokia.com/Community/Wiki/Controlling_the_camera_light_using_CCamera
 * 
 * (sono state apportate alcune modifiche per migliorare la compatibilità con S60 5th Edition 
 */


#ifndef __CAMERAFLASHLIGHT_H__
#define __CAMERAFLASHLIGHT_H__

// INCLUDES

#include <e32std.h>
#include <ecam.h> // link against ecam.lib

class CCameraFlashLight : public CBase, public MCameraObserver2
  {
  public:
  
    enum TCameraState
      {
      ECameraIdle,    // off (ready)
      ECameraInit,    // reserving or powering up
      ECameraRun,     // on (running capture)
      ECameraErr      // error
      };
      
  public:
    static CCameraFlashLight* NewL();
    ~CCameraFlashLight();
    
    void SetVideoLightL( TBool aOn );
    TCameraState State() { return iState; }
     
  private: 
    CCameraFlashLight() : iState(ECameraIdle) {}; 
    void ConstructL();
    
    void PrepareAndStartCaptureL();
    void StopCapture();

  private:
    // from MCameraObserver2    
    void HandleEvent( const TECAMEvent &aEvent );
    void ViewFinderReady( MCameraBuffer&, TInt );
    void ImageBufferReady( MCameraBuffer&, TInt );
    void VideoBufferReady( MCameraBuffer& aBuf, TInt aError );

    
  private:
    CCamera*      iCamera;
    TCameraInfo   iCameraInfo;
    TCameraState  iState;
  };

#endif // __CAMERAFLASHLIGHT_H__
